using System;

namespace ConsoleApp1
{
    class Program
    {

        struct Krv
        {
            public int broj;
            public string tip;
        }

        static void Main(string[] args)
        {
            bool t = true;
            int n = int.Parse(Console.ReadLine());
            int[] a = new int[5];
            int[,] c = new int[n + 1, 5];
            string[] s = Console.ReadLine().Split();
            for (int i = 0; i < 4; i++)
            {
                a[i] = int.Parse(s[i]);
            }
            Krv[] b = new Krv[n + 1];
            for (int i = 0; i < n; i++)
            {
                s = Console.ReadLine().Split();
                b[i].tip = s[0];
                b[i].broj = int.Parse(s[1]);
                if (t)
                {
                    if (String.Equals(b[i].tip, "O"))
                    {
                        c[i, 0] = b[i].broj;
                        a[0] -= b[i].broj;
                        if (a[0] < 0)
                        {
                            t = false;
                        }
                    }
                    else if (a[1] > 0 && String.Equals(b[i].tip, "A"))
                    {
                        c[i, 1] = (a[1] < b[i].broj) ? a[1] : b[i].broj;
                        a[1] -= b[i].broj;
                    }
                    else if (a[2] > 0 && String.Equals(b[i].tip, "B"))
                    {
                        c[i, 2] = (a[2] < b[i].broj) ? a[2] : b[i].broj;
                        a[2] -= b[i].broj;
                    }
                    else if (a[3] > 0 && String.Equals(b[i].tip, "AB"))
                    {
                        c[i, 3] = (a[3] < b[i].broj) ? a[3] : b[i].broj;
                        a[3] -= b[i].broj;
                    }
                }
            }
            for (int i = 0; t && i < n; i++)
            {
                if (String.Equals(b[i].tip, "A") && c[i, 1] < b[i].broj)
                {
                    c[i, 0] += b[i].broj - c[i, 1];
                    a[0] -= b[i].broj - c[i, 1];
                    if (a[0] < 0)
                    {
                        t = false;
                    }
                }
                else if (String.Equals(b[i].tip, "B") && c[i, 2] < b[i].broj)
                {
                    c[i, 0] += b[i].broj - c[i, 2];
                    a[0] -= b[i].broj - c[i, 2];
                    if (a[0] < 0)
                    {
                        t = false;
                    }
                }
            }
            for (int i = 0; t && i < n; i++)
            {
                if (String.Equals(b[i].tip, "AB") && c[i, 3] < b[i].broj)
                {
                    if (a[0] > 0)
                    {
                        c[i, 0] = (a[0] < b[i].broj - c[i, 3]) ? a[0] : b[i].broj - c[i, 3];
                        a[0] -= b[i].broj - c[i, 3];
                    }
                    if (a[1] > 0 && c[i, 0] + c[i, 3] < b[i].broj)
                    {
                        c[i, 1] = (a[1] < b[i].broj - c[i, 0] - c[i, 3]) ? a[1] : b[i].broj - c[i, 0] - c[i, 3];
                        a[1] -= b[i].broj - c[i, 0] - c[i, 3];
                    }
                    if (c[i, 0] + c[i, 1] + c[i, 3] < b[i].broj)
                    {
                        if (a[2] < b[i].broj - c[i, 0] - c[i, 1] - c[i, 3])
                        {
                            t = false;
                        }
                        else
                        {
                            c[i, 2] = b[i].broj - c[i, 0] - c[i, 1] - c[i, 3];
                            a[2] -= c[i, 2];
                        }
                    }
                }
            }
            if (t)
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                {
                    for (int j = 0; j < 4; j++)
                    {
                        Console.Write("{0} ", c[i, j]);
                    }
                    Console.WriteLine();
                }
            }
            else
            {
                Console.WriteLine("nemoguce");
            }
        }
    }
}